object Demo extends org.codecop.basic.BasicApplication {
   println("start")
    
   // first try with implicit conversion to PRINT method
   10 PRINT "Hello World"    
   20 PRINT 12 + 12
   30 PRINT 144/12
   // 40 PRINT 12 ^ 5
   // 40 PRINT "a" ; "b"
   // PROBLEM: ";" is resevred, can't use it for PRINT "a";"b"
   // 50 PRINT "a" , "b"
   // PROBLEM: single opchars like "," cab't be used for PRINT "a","b"
   RUN
    
   NEW
   // second add GOTO and program flow
   10 ? "Commodore 64"
   20 GOTO 10
   // RUN

   NEW
   // third add variables
   // 10 `X%` = 15
   // PROBLEM: "%" is not allowed as suffix for integers, would need `X%`
   // PROBLEM: can't parse arbritrary variables, but can generate code for all pairs.
   20 X = 23.5
   30 X$ = "THE SUM OF X% + X = "
   50 PRINT X$
   // 40 PRINT "X% = "; X%, "X = ";X
   // 50 PRINT X$; X% + X
   RUN
   
   NEW
   // more commands in same line
   10 PRINT "Commodore 64" GOTO 10
   // PROBLEM: ":" does not work on its own, "::" does not work without parentesis
   // RUN
   
   NEW
   // add IF 
   10 X = 0
   20 ? "COMMODORE 64"
   30 X = X + 1
   40 IF X < 5 THEN 20
   50 END // we need this odd empty line here, otherwise END thinks its an parameter
   
   60 GOTO 10
   RUN
   
   NEW
   // add FOR
   10 FOR X = 1 TO 5 
   20 PRINT "COMMODORE 64"
   30 NEXT X 
   RUN
    
   NEW
   // add STEP
   10 FOR X = 10 TO 1 STEP -.5
   20 PRINT X
   30 NEXT X
   RUN
   
   NEW
   // add INPUT
   10 INPUT X$
   20 PRINT "YOU ENTERED: "
   30 PRINT X$
   40 GOTO 10
   // RUN
   
   NEW
   // add GET
   10 GET X$ IF X$=="" THEN 10
   // PROBLEM we have to use == for equality, but could add my own assignments expected by IF...
   20 PRINT X$
   30 GOTO 10
   // RUN
   
   NEW
   // adding functions is easy
   20 PRINT INT(6*RND(1))+1   
   30 PRINT ASC("X")
   40 PRINT CHR$(65)
   RUN

   // continue page 53
   
   println("end")
}
