package org.codecop.basic

// ---------- runtime errors ----------

abstract class BasicError(msg:String) extends RuntimeException(msg)

class SyntaxError(msg:String) extends BasicError(msg)

class NextWithoutForError(msg:String) extends BasicError(msg)

class LineNotFoundError(line:Int) extends BasicError(line.toString)

